#include <iostream>

using namespace std;

struct Prvek
{
	int data;
	Prvek* dalsi;
};
struct Seznam
{
	Prvek* prvni;
	Prvek* posledni;	
};
Seznam* seznam;
void vytvorSeznam()
{
	seznam = new Seznam;
	seznam->prvni = new Prvek;
	seznam->posledni = seznam->prvni;
}
void pridejNaZacatek(int cislo)
{
	Prvek* novyPrvek = new Prvek;
	novyPrvek->data = cislo;
	novyPrvek->dalsi = seznam->prvni;
	seznam->prvni = novyPrvek;
}
void pridejNaKonec(int cislo)
{
	Prvek* posledniPrvek = seznam->posledni;
	posledniPrvek->data = cislo;
	posledniPrvek->dalsi = new Prvek;
	seznam->posledni = posledniPrvek->dalsi;
}
void vypisSeznam()
{
	Prvek* aktualniPrvek = seznam->prvni;
	while(aktualniPrvek != seznam->posledni)
	{
		cout << aktualniPrvek->data << ", ";
		aktualniPrvek = aktualniPrvek->dalsi;
	}
	cout << endl;
}
bool jeSeznamPrazdny()
{
	return seznam->prvni == seznam->posledni;	
}
void odstranPrvni()
{
	//if(jeSeznamPrazdny() == false)
	if(!jeSeznamPrazdny())
	{
		Prvek* prvekKOdstraneni = seznam->prvni;
		seznam->prvni = prvekKOdstraneni->dalsi;
		delete prvekKOdstraneni;
	}
}
void vyprazdniSeznam()
{
	while(!jeSeznamPrazdny())
	{
		odstranPrvni();
	}
}
void odstranSeznam()
{
	vyprazdniSeznam();
	delete seznam->prvni;
	delete seznam;
}
bool najdiPrvek(int cislo)
{
	Prvek* aktualniPrvek = seznam->prvni;
	while(aktualniPrvek != seznam->posledni)
	{
		if(aktualniPrvek->data == cislo)
		{
			return true;
		}
		aktualniPrvek = aktualniPrvek->dalsi;
	}
	return false;
}
bool najdiPrvek2(int cislo)
{
	Prvek* aktualniPrvek = seznam->prvni;
	Prvek* posledniPrvek = seznam->posledni;
	posledniPrvek->data = cislo;
	while(aktualniPrvek->data != cislo)
	{
		aktualniPrvek = aktualniPrvek->dalsi;
	}
	return aktualniPrvek != posledniPrvek;
	/*if(aktualniPrvek == posledniPrvek)
	{
		return false;
	}
	else
	{
		return true;
	}*/
}
int main()
{
	vytvorSeznam();
	pridejNaZacatek(5);
	pridejNaZacatek(8);
	pridejNaZacatek(4);
	pridejNaZacatek(2);
	pridejNaKonec(99);
	vypisSeznam();
	if(najdiPrvek2(2))
	{
		cout << "Prvek je v seznamu" << endl;
	}
	else
	{
		cout << "Prvek neni v seznamu" << endl;
	}
	/*odstranPrvni();
	vypisSeznam();
	vyprazdniSeznam();
	vypisSeznam();*/
	odstranSeznam();
	return 0;
}
